=== modified file 'lib/canonical/launchpad/webapp/adapter.py'
--- lib/canonical/launchpad/webapp/adapter.py	2011-07-07 11:39:17 +0000
+++ lib/canonical/launchpad/webapp/adapter.py	2011-08-10 01:00:53 +0000
@@ -37,6 +37,7 @@
 from storm.store import Store
 from storm.tracer import install_tracer
 from storm.zope.interfaces import IZStorm
+from timeline.timeline import Timeline
 import transaction
 from zope.component import getUtility
 from zope.interface import (
@@ -73,7 +74,6 @@
 from canonical.lazr.timeout import set_default_timeout_function
 from lp.services import features
 from lp.services.log.loglevels import DEBUG2
-from lp.services.timeline.timeline import Timeline
 from lp.services.timeline.requesttimeline import (
     get_request_timeline,
     set_request_timeline,

=== modified file 'lib/lp/services/timeline/__init__.py'
--- lib/lp/services/timeline/__init__.py	2010-09-01 07:09:20 +0000
+++ lib/lp/services/timeline/__init__.py	2011-08-10 01:00:53 +0000
@@ -1,14 +1,11 @@
 # Copyright 2010 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
-"""lp.services.timeline provides a timeline for varied actions.
+"""lp.services.timeline provides the Launchpad glue for using timeline.
 
 This is used as part of determining where time goes in a request.
 
 NOTE that it is not LP's timeline-view for products, though they are similar in
 intent and concept (If a better name presents itself, this package may be
 renamed).
-
-Because this is part of lp.services, packages in this namespace can only use
-general LAZR or library functionality.
 """

=== removed file 'lib/lp/services/timeline/nestingtimedaction.py'
--- lib/lp/services/timeline/nestingtimedaction.py	2011-04-20 05:05:06 +0000
+++ lib/lp/services/timeline/nestingtimedaction.py	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-# Copyright 2010 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Time an action which calls other timed actions."""
-
-
-__all__ = ['NestingTimedAction']
-
-__metaclass__ = type
-
-
-import datetime
-
-from timedaction import TimedAction
-
-
-class NestingTimedAction(TimedAction):
-    """A variation of TimedAction which creates a nested environment.
-    
-    This is done by recording two 0 length timed actions in the timeline:
-    one at the start of the action and one at the end, with -start and
-    -stop appended to their categories.
-
-    See `TimedAction` for more information.
-    """
-
-    def _init(self):
-        self.duration = datetime.timedelta()
-        self._category = self.category
-        self.category = self._category + '-start'
-
-    def finish(self):
-        """Mark the TimedAction as finished."""
-        end = self.timeline.start(self._category + '-stop', self.detail)
-        end.duration = datetime.timedelta()

=== modified file 'lib/lp/services/timeline/requesttimeline.py'
--- lib/lp/services/timeline/requesttimeline.py	2010-09-01 09:53:27 +0000
+++ lib/lp/services/timeline/requesttimeline.py	2011-08-10 01:00:53 +0000
@@ -10,12 +10,13 @@
 
 __metaclass__ = type
 
+from timeline import Timeline
+
 # XXX RobertCollins 2010-09-01 bug=623199: Undesirable but pragmatic.
 # Because of this bug, rather than using request.annotations we have
 # to work in with the webapp.adapter request model, which is 
 # different to that used by get_current_browser_request.
 from canonical.launchpad import webapp
-from timeline import Timeline
 
 
 def get_request_timeline(request):
@@ -27,7 +28,7 @@
     request annotations.
 
     :param request: A zope/launchpad request object.
-    :return: A lp.services.timeline.timeline.Timeline object for the request.
+    :return: A timeline.timeline.Timeline object for the request.
     """
     try:
         return webapp.adapter._local.request_timeline

=== removed file 'lib/lp/services/timeline/tests/test_nestingtimedaction.py'
--- lib/lp/services/timeline/tests/test_nestingtimedaction.py	2011-04-20 05:05:06 +0000
+++ lib/lp/services/timeline/tests/test_nestingtimedaction.py	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-# Copyright 2010 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Tests of the TimedAction class."""
-
-__metaclass__ = type
-
-import datetime
-
-import testtools
-
-from lp.services.timeline.nestingtimedaction import NestingTimedAction
-from lp.services.timeline.timeline import Timeline
-
-
-class TestNestingTimedAction(testtools.TestCase):
-
-    def test_finish_adds_action(self):
-        timeline = Timeline()
-        action = NestingTimedAction("Sending mail", None, timeline)
-        action.finish()
-        self.assertEqual(1, len(timeline.actions))
-        self.assertEqual(datetime.timedelta(), timeline.actions[-1].duration)
-
-    def test__init__sets_duration(self):
-        action = NestingTimedAction("Sending mail", None)
-        self.assertEqual(datetime.timedelta(), action.duration)

=== modified file 'lib/lp/services/timeline/tests/test_requesttimeline.py'
--- lib/lp/services/timeline/tests/test_requesttimeline.py	2010-09-01 08:48:55 +0000
+++ lib/lp/services/timeline/tests/test_requesttimeline.py	2011-08-10 01:00:53 +0000
@@ -6,6 +6,7 @@
 __metaclass__ = type
 
 import testtools
+from timeline.timeline import OverlappingActionError, Timeline
 from zope.publisher.browser import TestRequest
 
 from canonical.launchpad import webapp
@@ -13,7 +14,6 @@
     get_request_timeline,
     set_request_timeline,
     )
-from lp.services.timeline.timeline import OverlappingActionError, Timeline
 
 
 class TestRequestTimeline(testtools.TestCase):

=== removed file 'lib/lp/services/timeline/tests/test_timedaction.py'
--- lib/lp/services/timeline/tests/test_timedaction.py	2010-09-06 22:41:18 +0000
+++ lib/lp/services/timeline/tests/test_timedaction.py	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-# Copyright 2010 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Tests of the TimedAction class."""
-
-__metaclass__ = type
-
-import datetime
-
-import testtools
-
-from lp.services.timeline.timedaction import TimedAction
-from lp.services.timeline.timeline import Timeline
-
-
-class TestTimedAction(testtools.TestCase):
-
-    def test_starts_now(self):
-        action = TimedAction("Sending mail", None)
-        self.assertIsInstance(action.start, datetime.datetime)
-
-    def test_finish_sets_duration(self):
-        action = TimedAction("Sending mail", None)
-        self.assertEqual(None, action.duration)
-        action.finish()
-        self.assertIsInstance(action.duration, datetime.timedelta)
-
-    def test__init__sets_category(self):
-        action = TimedAction("Sending mail", None)
-        self.assertEqual("Sending mail", action.category)
-
-    def test__init__sets_detail(self):
-        action = TimedAction(None, "fred.jones@example.com")
-        self.assertEqual("fred.jones@example.com", action.detail)
-
-    def test_logTuple(self):
-        timeline = Timeline()
-        action = TimedAction("foo", "bar", timeline)
-        # Set variable for deterministic results
-        action.start = timeline.baseline + datetime.timedelta(0, 0, 0, 2)
-        action.duration = datetime.timedelta(0, 0, 0, 4)
-        log_tuple = action.logTuple()
-        self.assertEqual(4, len(log_tuple), "!= 4 elements %s" % (log_tuple,))
-        # The first element is the start offset in ms.
-        self.assertAlmostEqual(2, log_tuple[0])
-        # The second element is the end offset in ms.
-        self.assertAlmostEqual(6, log_tuple[1])
-        self.assertEqual("foo", log_tuple[2])
-        self.assertEqual("bar", log_tuple[3])
-
-    def test_logTupleIncomplete(self):
-        # Things that start and hit a timeout *may* not get recorded as
-        # finishing in normal operation.
-        timeline = Timeline()
-        action = TimedAction("foo", "bar", timeline)
-        # Set variable for deterministic results
-        action.start = timeline.baseline + datetime.timedelta(0, 0, 0, 2)
-        action._interval_to_now = lambda: datetime.timedelta(0, 0, 0, 3)
-        log_tuple = action.logTuple()
-        self.assertEqual(4, len(log_tuple), "!= 4 elements %s" % (log_tuple,))
-        self.assertAlmostEqual(2, log_tuple[0])
-        self.assertAlmostEqual(5, log_tuple[1])
-        self.assertEqual("foo", log_tuple[2])
-        self.assertEqual("bar", log_tuple[3])

=== removed file 'lib/lp/services/timeline/tests/test_timeline.py'
--- lib/lp/services/timeline/tests/test_timeline.py	2011-04-20 04:06:53 +0000
+++ lib/lp/services/timeline/tests/test_timeline.py	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-# Copyright 2010 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Tests of the Timeline class."""
-
-__metaclass__ = type
-
-import datetime
-
-import testtools
-
-from lp.services.timeline.timedaction import TimedAction
-from lp.services.timeline.timeline import OverlappingActionError, Timeline
-
-
-class TestTimeline(testtools.TestCase):
-
-    def test_start_returns_action(self):
-        timeline = Timeline()
-        action = timeline.start("Sending mail", "Noone")
-        self.assertIsInstance(action, TimedAction)
-        self.assertEqual("Sending mail", action.category)
-        self.assertEqual("Noone", action.detail)
-        self.assertEqual(None, action.duration)
-        self.assertEqual(timeline, action.timeline)
-
-    def test_can_supply_list(self):
-        actions = "foo"
-        timeline = Timeline(actions)
-        self.assertEqual(actions, timeline.actions)
-
-    def test_start_with_unfinished_action_fails(self):
-        # A design constraint of timeline says that overlapping actions are not
-        # permitted. See the Timeline docstrings.
-        timeline = Timeline()
-        action = timeline.start("Sending mail", "Noone")
-        self.assertRaises(OverlappingActionError, timeline.start,
-            "Sending mail", "Noone")
-
-    def test_nested_start_permitted(self):
-        # When explicitly requested a nested start can be done
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        child = timeline.start("SQL Callback", "SELECT...")
-
-    def test_nested_start_is_not_transitive(self):
-        # nesting is explicit at each level - not inherited.
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        child = timeline.start("SQL Callback", "SELECT...")
-        self.assertRaises(OverlappingActionError, timeline.start,
-            "Sending mail", "Noone")
-
-    def test_multiple_nested_children_permitted(self):
-        # nesting is not reset by each action that is added.
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        child = timeline.start("SQL Callback", "SELECT...")
-        child.finish()
-        child = timeline.start("SQL Callback", "SELECT...")
-
-    def test_multiple_starts_after_nested_group_prevented(self):
-        # nesting stops being permitted when the nesting action is finished.
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        action.finish()
-        child = timeline.start("SQL Callback", "SELECT...")
-        self.assertRaises(OverlappingActionError, timeline.start,
-            "Sending mail", "Noone")
-
-    def test_nesting_within_nesting_permitted(self):
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        middle = timeline.start("Calling otherlibrary", "", allow_nested=True)
-        child = timeline.start("SQL Callback", "SELECT...")
-
-    def test_finishing_nested_within_nested_leaves_outer_nested_nesting(self):
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        middle = timeline.start("Calling otherlibrary", "", allow_nested=True)
-        middle.finish()
-        child = timeline.start("SQL Callback", "SELECT...")
-
-    def test_nested_actions_recorded_as_two_zero_length_actions(self):
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        child = timeline.start("SQL Callback", "SELECT...")
-        child.finish()
-        action.finish()
-        self.assertEqual(3, len(timeline.actions))
-        self.assertEqual(datetime.timedelta(), timeline.actions[0].duration)
-        self.assertEqual(datetime.timedelta(), timeline.actions[2].duration)
-
-    def test_nested_category_labels(self):
-        # To identify start/stop pairs '-start' and '-stop' are put onto the
-        # category of nested actions:
-        timeline = Timeline()
-        action = timeline.start("Calling openid", "hostname", allow_nested=True)
-        action.finish()
-        self.assertEqual('Calling openid-start', timeline.actions[0].category)
-        self.assertEqual('Calling openid-stop', timeline.actions[1].category)
-
-    def test_start_after_finish_works(self):
-        timeline = Timeline()
-        action = timeline.start("Sending mail", "Noone")
-        action.finish()
-        action = timeline.start("Sending mail", "Noone")
-        action.finish()
-        self.assertEqual(2, len(timeline.actions))
-
-    def test_baseline(self):
-        timeline = Timeline()
-        self.assertIsInstance(timeline.baseline, datetime.datetime)

=== removed file 'lib/lp/services/timeline/timedaction.py'
--- lib/lp/services/timeline/timedaction.py	2011-04-20 04:06:53 +0000
+++ lib/lp/services/timeline/timedaction.py	1970-01-01 00:00:00 +0000
@@ -1,81 +0,0 @@
-# Copyright 2010 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Time a single categorised action."""
-
-
-__all__ = ['TimedAction']
-
-__metaclass__ = type
-
-
-import datetime
-
-import pytz
-
-
-UTC = pytz.utc
-
-
-class TimedAction:
-    """An individual action which has been timed.
-
-    :ivar timeline: The timeline that this action took place within.
-    :ivar start: A datetime object with tz for the start of the action.
-    :ivar duration: A timedelta for the duration of the action. None for
-        actions which have not completed.
-    :ivar category: The category of the action. E.g. "sql".
-    :ivar detail: The detail about the action. E.g. "SELECT COUNT(*) ..."
-    """
-
-    def __init__(self, category, detail, timeline=None):
-        """Create a TimedAction.
-
-        New TimedActions have a start but no duration.
-
-        :param category: The category for the action.
-        :param detail: The detail about the action being timed.
-        :param timeline: The timeline for the action.
-        """
-        self.start = datetime.datetime.now(UTC)
-        self.duration = None
-        self.category = category
-        self.detail = detail
-        self.timeline = timeline
-        self._init()
-
-    def _init(self):
-        # hook for child classes.
-        pass
-
-    def __repr__(self):
-        return "<%s %s[%s]>" % (self.__class__, self.category,
-            self.detail[:20])
-
-    def logTuple(self):
-        """Return a 4-tuple suitable for errorlog's use."""
-        offset = self._td_to_ms(self.start - self.timeline.baseline)
-        if self.duration is None:
-            # This action wasn't finished: pretend it has finished now
-            # (even though it hasn't). This is pretty normal when action ends
-            # are recorded by callbacks rather than stack-like structures. E.g.
-            # storm tracers in launchpad:
-            # log-trace START : starts action
-            # timeout-trace START : raises 
-            # log-trace FINISH is never called.
-            length = self._td_to_ms(self._interval_to_now())
-        else:
-            length = self._td_to_ms(self.duration)
-        return (offset, offset + length, self.category, self.detail)
-
-    def _td_to_ms(self, td):
-        """Tweak on a backport from python 2.7"""
-        return (td.microseconds + (
-            td.seconds + td.days * 24 * 3600) * 10**6) / 10**3
-
-    def finish(self):
-        """Mark the TimedAction as finished."""
-        self.duration = self._interval_to_now()
-
-    def _interval_to_now(self):
-        return datetime.datetime.now(UTC) - self.start

=== removed file 'lib/lp/services/timeline/timeline.py'
--- lib/lp/services/timeline/timeline.py	2011-04-20 04:06:53 +0000
+++ lib/lp/services/timeline/timeline.py	1970-01-01 00:00:00 +0000
@@ -1,74 +0,0 @@
-# Copyright 2010 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-"""Coordinate a sequence of non overlapping TimedActionss."""
-
-__all__ = ['Timeline']
-
-__metaclass__ = type
-
-import datetime
-
-from pytz import utc as UTC
-
-from timedaction import TimedAction
-from nestingtimedaction import NestingTimedAction
-
-
-class OverlappingActionError(Exception):
-    """A new action was attempted without finishing the prior one."""
-    # To make analysis easy we do not permit overlapping actions by default:
-    # each action that is being timed and accrued must complete before the next
-    # is started. This means, for instance, that sending mail cannot do SQL
-    # queries, as both are timed and accrued. OTOH it makes analysis and
-    # serialisation of timelines simpler, and for the current use cases in 
-    # Launchpad this is sufficient. This constraint should not be considered
-    # sacrosanct - if, in future, we desire timelines with overlapping actions,
-    # as long as the OOPS analysis code is extended to generate sensible
-    # reports in those situations, this can be changed. In the interim, actions
-    # can be explicitly setup to permit nesting by passing allow_nested=True
-    # which will cause the action to be recorded with 0 duration and a -start
-    # and -stop suffix added to its category. This is potentially lossy but
-    # good enough to get nested metrics and can be iterated on in the future to
-    # do an actual stacked/tree model of actions - if needed.
-
-
-class Timeline:
-    """A sequence of TimedActions.
-
-    This is used for collecting expensive/external actions inside Launchpad
-    requests.
-
-    :ivar actions: The actions.
-    :ivar baseline: The point the timeline starts at.
-    """
-
-    def __init__(self, actions=None):
-        """Create a Timeline.
-        
-        :param actions: An optional object to use to store the timeline. This
-            must implement the list protocol.
-        """
-        if actions is None:
-            actions = []
-        self.actions = actions
-        self.baseline = datetime.datetime.now(UTC)
-
-    def start(self, category, detail, allow_nested=False):
-        """Create a new TimedAction at the end of the timeline.
-
-        :param category: the category for the action.
-        :param detail: The detail for the action.
-        :param allow_nested: If True treat this action as a nested action -
-            record it twice with 0 duration, once at the start and once at the
-            finish.
-        :return: A TimedAction for that category and detail.
-        """
-        if allow_nested:
-            result = NestingTimedAction(category, detail, self)
-        else:
-            result = TimedAction(category, detail, self)
-        if self.actions and self.actions[-1].duration is None:
-            raise OverlappingActionError(self.actions[-1], result)
-        self.actions.append(result)
-        return result

=== modified file 'setup.py'
--- setup.py	2011-08-08 19:25:38 +0000
+++ setup.py	2011-08-10 01:00:53 +0000
@@ -74,6 +74,7 @@
         'sourcecodegen',
         'storm',
         'testtools',
+        'timeline',
         'transaction',
         'Twisted',
         'wadllib',

=== modified file 'versions.cfg'
--- versions.cfg	2011-08-08 20:29:58 +0000
+++ versions.cfg	2011-08-10 01:00:53 +0000
@@ -81,6 +81,7 @@
 storm = 0.18.0.99-lpwithnodatetime-r393
 testresources = 0.2.4-r58
 testtools = 0.9.12-r194
+timeline = 0.0.1
 transaction = 1.0.0
 txamqp = 0.4
 Twisted = 11.0.0

